libzypp 17.37.10

AutoDispose.h File Reference
`#include <iosfwd>`
`#include <boost/call_traits.hpp>`
`#include <utility>`
`#include <zypp-core/base/NonCopyable.h>`
`#include <zypp-core/base/PtrTypes.h>`
`#include <zypp-core/base/Function.h>`
`#include <zypp-core/Pathname.h>`

Go to the source code of this file.

## Classes
class | zypp::AutoDispose< Tp >
| Reference counted access to a `Tp` object calling a custom `Dispose` function when the last AutoDispose handle to it is destroyed or reset. More...
struct | zypp::AutoDispose< Tp >::Impl
class | zypp::AutoDispose< void >
struct | zypp::AutoDispose< void >::Impl
struct | zypp::Deferred
class | zypp::AutoFD
| AutoDispose<int> calling `::close` More...
class | zypp::AutoFILE
| AutoDispose<FILE*> calling `::fclose` More...
struct | zypp::AutoFREE< Tp >
struct | zypp::AutoFREE< void >

## Namespaces
namespace | zypp
| Easy-to use interface to the ZYPP dependency resolver.

## Macros
#define | __zypp_defer_concatenate(__lhs, __rhs)
#define | __zypp_defer_declarator(__id)
#define | zypp_defer __zypp_defer_declarator(__LINE__)

## Typedefs
using | zypp::OnScopeExit = AutoDispose<void>

## Macro Definition Documentation

## ◆ __zypp_defer_concatenate

#define __zypp_defer_concatenate | ( |  | __lhs,
|  |  | __rhs )

Value:
__lhs##__rhs

Definition at line 287 of file AutoDispose.h.

## ◆ __zypp_defer_declarator

#define __zypp_defer_declarator | ( |  | __id | ) |

Value:
zypp::Deferred __zypp_defer_concatenate(__defer, __id) = [&]()
zypp::Deferred
Definition AutoDispose.h:279
__zypp_defer_concatenate
#define __zypp_defer_concatenate(__lhs, __rhs)
Definition AutoDispose.h:287

Definition at line 290 of file AutoDispose.h.

## ◆ zypp_defer

#define zypp_defer __zypp_defer_declarator(__LINE__)

Definition at line 293 of file AutoDispose.h.